BasicManagedDataSource (Apache Tomcat 9.0.107 API Documentation)
Description: declaration: package: org.apache.tomcat.dbcp.dbcp2.managed, class: BasicManagedDataSource

# Class BasicManagedDataSource

java.lang.Object
org.apache.tomcat.dbcp.dbcp2.BasicDataSource
org.apache.tomcat.dbcp.dbcp2.managed.BasicManagedDataSource

All Implemented Interfaces:
  `AutoCloseable`, `Wrapper`, `MBeanRegistration`, `CommonDataSource`, `DataSource`, `BasicDataSourceMXBean`, `DataSourceMXBean`

public class BasicManagedDataSource extends BasicDataSource

BasicManagedDataSource is an extension of BasicDataSource which creates ManagedConnections. This data source can create either full two-phase-commit XA connections or one-phase-commit local connections. Both types of connections are committed or rolled back as part of the global transaction (a.k.a. XA transaction or JTA Transaction), but only XA connections can be recovered in the case of a system crash.

BasicManagedDataSource adds the TransactionManager and XADataSource properties. The TransactionManager property is required and is used to enlist connections in global transactions. The XADataSource is optional and if set is the class name of the XADataSource class for a two-phase-commit JDBC driver. If the XADataSource property is set, the driverClassName is ignored and a DataSourceXAConnectionFactory is created. Otherwise, a standard DriverConnectionFactory is created and wrapped with a LocalXAConnectionFactory.

Since:
  2.0
See Also:
  - `BasicDataSource`
  - `ManagedConnection`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `BasicManagedDataSource()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected ConnectionFactory`
  `createConnectionFactory()`
  Creates a JDBC connection factory for this data source.
  `protected DataSource`
  `createDataSourceInstance()`
  Creates the actual data source instance.
  `protected PoolableConnectionFactory`
  `createPoolableConnectionFactory(ConnectionFactory driverConnectionFactory)`
  Creates the PoolableConnectionFactory and attaches it to the connection pool.
  `TransactionManager`
  `getTransactionManager()`
  Gets the required transaction manager property.
  `protected TransactionRegistry`
  `getTransactionRegistry()`
  Gets the transaction registry.
  `TransactionSynchronizationRegistry`
  `getTransactionSynchronizationRegistry()`
  Gets the optional TransactionSynchronizationRegistry.
  `String`
  `getXADataSource()`
  Gets the optional XADataSource class name.
  `XADataSource`
  `getXaDataSourceInstance()`
  Gets the XADataSource instance used by the XAConnectionFactory.
  `void`
  `setTransactionManager(TransactionManager transactionManager)`
  Sets the required transaction manager property.
  `void`
  `setTransactionSynchronizationRegistry(TransactionSynchronizationRegistry transactionSynchronizationRegistry)`
  Sets the optional TransactionSynchronizationRegistry property.
  `void`
  `setXADataSource(String xaDataSource)`
  Sets the optional XADataSource class name.
  `void`
  `setXaDataSourceInstance(XADataSource xaDataSourceInstance)`
  Sets the XADataSource instance used by the XAConnectionFactory.

  ### Methods inherited from class org.apache.tomcat.dbcp.dbcp2.BasicDataSource

  `addConnectionProperty, close, createConnectionPool, createDataSource, createObjectPool, evict, getAbandonedLogWriter, getAbandonedUsageTracking, getAutoCommitOnReturn, getCacheState, getConnection, getConnection, getConnectionFactoryClassName, getConnectionInitSqls, getConnectionInitSqlsAsArray, getConnectionPool, getDefaultAutoCommit, getDefaultCatalog, getDefaultQueryTimeout, getDefaultQueryTimeoutDuration, getDefaultReadOnly, getDefaultSchema, getDefaultTransactionIsolation, getDisconnectionIgnoreSqlCodes, getDisconnectionIgnoreSqlCodesAsArray, getDisconnectionSqlCodes, getDisconnectionSqlCodesAsArray, getDriver, getDriverClassLoader, getDriverClassName, getDurationBetweenEvictionRuns, getEnableAutoCommitOnReturn, getEvictionPolicyClassName, getFastFailValidation, getInitialSize, getJmxName, getLifo, getLogAbandoned, getLogExpiredConnections, getLoginTimeout, getLogWriter, getMaxConnDuration, getMaxConnLifetimeMillis, getMaxIdle, getMaxOpenPreparedStatements, getMaxTotal, getMaxWaitDuration, getMaxWaitMillis, getMinEvictableIdleDuration, getMinEvictableIdleTimeMillis, getMinIdle, getNumActive, getNumIdle, getNumTestsPerEvictionRun, getParentLogger, getPassword, getRegisteredJmxName, getRemoveAbandonedOnBorrow, getRemoveAbandonedOnMaintenance, getRemoveAbandonedTimeout, getRemoveAbandonedTimeoutDuration, getRollbackOnReturn, getSoftMinEvictableIdleDuration, getSoftMinEvictableIdleTimeMillis, getTestOnBorrow, getTestOnCreate, getTestOnReturn, getTestWhileIdle, getTimeBetweenEvictionRunsMillis, getUrl, getUsername, getValidationQuery, getValidationQueryTimeout, getValidationQueryTimeoutDuration, invalidateConnection, isAccessToUnderlyingConnectionAllowed, isClearStatementPoolOnReturn, isClosed, isPoolPreparedStatements, isWrapperFor, log, log, postDeregister, postRegister, preDeregister, preRegister, removeConnectionProperty, restart, setAbandonedLogWriter, setAbandonedUsageTracking, setAccessToUnderlyingConnectionAllowed, setAutoCommitOnReturn, setCacheState, setClearStatementPoolOnReturn, setConnectionFactoryClassName, setConnectionInitSqls, setConnectionInitSqls, setConnectionProperties, setDefaultAutoCommit, setDefaultCatalog, setDefaultQueryTimeout, setDefaultQueryTimeout, setDefaultReadOnly, setDefaultSchema, setDefaultTransactionIsolation, setDisconnectionIgnoreSqlCodes, setDisconnectionSqlCodes, setDriver, setDriverClassLoader, setDriverClassName, setDurationBetweenEvictionRuns, setEnableAutoCommitOnReturn, setEvictionPolicyClassName, setFastFailValidation, setInitialSize, setJmxName, setLifo, setLogAbandoned, setLogExpiredConnections, setLoginTimeout, setLogWriter, setMaxConn, setMaxConnLifetimeMillis, setMaxIdle, setMaxOpenPreparedStatements, setMaxTotal, setMaxWait, setMaxWaitMillis, setMinEvictableIdle, setMinEvictableIdleTimeMillis, setMinIdle, setNumTestsPerEvictionRun, setPassword, setPoolPreparedStatements, setRegisterConnectionMBean, setRemoveAbandonedOnBorrow, setRemoveAbandonedOnMaintenance, setRemoveAbandonedTimeout, setRemoveAbandonedTimeout, setRollbackOnReturn, setSoftMinEvictableIdle, setSoftMinEvictableIdleTimeMillis, setTestOnBorrow, setTestOnCreate, setTestOnReturn, setTestWhileIdle, setTimeBetweenEvictionRunsMillis, setUrl, setUsername, setValidationQuery, setValidationQueryTimeout, setValidationQueryTimeout, start, startPoolMaintenance, unwrap, validateConnectionFactory`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface javax.sql.CommonDataSource

  `createShardingKeyBuilder`

  ### Methods inherited from interface javax.sql.DataSource

  `createConnectionBuilder`

  ### Methods inherited from interface org.apache.tomcat.dbcp.dbcp2.DataSourceMXBean

  `getUserName`

- ## Constructor Details

  - ### BasicManagedDataSource

    public BasicManagedDataSource()

- ## Method Details

  - ### createConnectionFactory

    protected ConnectionFactory createConnectionFactory() throws SQLException
    Description copied from class: `BasicDataSource`
    Creates a JDBC connection factory for this data source. The JDBC driver is loaded using the following algorithm:
    1. If a Driver instance has been specified via `BasicDataSource.setDriver(Driver)` use it
    2. If no Driver instance was specified and {code driverClassName} is specified that class is loaded using the `ClassLoader` of this class or, if {code driverClassLoader} is set, {code driverClassName} is loaded with the specified `ClassLoader`.
    3. If {code driverClassName} is specified and the previous attempt fails, the class is loaded using the context class loader of the current thread.
    4. If a driver still isn't loaded one is loaded via the `DriverManager` using the specified {code connectionString}.

    This method exists so subclasses can replace the implementation class.

    Overrides:
      `createConnectionFactory` in class `BasicDataSource`
    Returns:
      A new connection factory.
    Throws:
      `SQLException` - If the connection factory cannot be created

  - ### createDataSourceInstance

    protected DataSource createDataSourceInstance() throws SQLException
    Description copied from class: `BasicDataSource`
    Creates the actual data source instance. This method only exists so that subclasses can replace the implementation class.
    Overrides:
      `createDataSourceInstance` in class `BasicDataSource`
    Returns:
      A new DataSource instance
    Throws:
      `SQLException` - if unable to create a datasource instance

  - ### createPoolableConnectionFactory

    protected PoolableConnectionFactory createPoolableConnectionFactory(ConnectionFactory driverConnectionFactory) throws SQLException
    Creates the PoolableConnectionFactory and attaches it to the connection pool.
    Overrides:
      `createPoolableConnectionFactory` in class `BasicDataSource`
    Parameters:
      `driverConnectionFactory` - JDBC connection factory created by `createConnectionFactory()`
    Returns:
      A new PoolableConnectionFactory configured with the current configuration of this BasicDataSource
    Throws:
      `SQLException` - if an error occurs creating the PoolableConnectionFactory

  - ### getTransactionManager

    public TransactionManager getTransactionManager()
    Gets the required transaction manager property.
    Returns:
      the transaction manager used to enlist connections

  - ### getTransactionRegistry

    protected TransactionRegistry getTransactionRegistry()
    Gets the transaction registry.
    Returns:
      the transaction registry associating XAResources with managed connections

  - ### getTransactionSynchronizationRegistry

    public TransactionSynchronizationRegistry getTransactionSynchronizationRegistry()
    Gets the optional TransactionSynchronizationRegistry.
    Returns:
      the TSR that can be used to register synchronizations.
    Since:
      2.6.0

  - ### getXADataSource

    public String getXADataSource()
    Gets the optional XADataSource class name.
    Returns:
      the optional XADataSource class name

  - ### getXaDataSourceInstance

    public XADataSource getXaDataSourceInstance()
    Gets the XADataSource instance used by the XAConnectionFactory.
    Returns:
      the XADataSource

  - ### setTransactionManager

    public void setTransactionManager(TransactionManager transactionManager)
    Sets the required transaction manager property.
    Parameters:
      `transactionManager` - the transaction manager used to enlist connections

  - ### setTransactionSynchronizationRegistry

    public void setTransactionSynchronizationRegistry(TransactionSynchronizationRegistry transactionSynchronizationRegistry)
    Sets the optional TransactionSynchronizationRegistry property.
    Parameters:
      `transactionSynchronizationRegistry` - the TSR used to register synchronizations
    Since:
      2.6.0

  - ### setXADataSource

    public void setXADataSource(String xaDataSource)
    Sets the optional XADataSource class name.
    Parameters:
      `xaDataSource` - the optional XADataSource class name

  - ### setXaDataSourceInstance

    public void setXaDataSourceInstance(XADataSource xaDataSourceInstance)
    Sets the XADataSource instance used by the XAConnectionFactory.

    Note: this method currently has no effect once the pool has been initialized. The pool is initialized the first time one of the following methods is invoked: `BasicDataSource.getConnection()`, `BasicDataSource.setLogWriter(java.io.PrintWriter)`, `BasicDataSource.setLoginTimeout(int)`, `BasicDataSource.getLoginTimeout()`, `BasicDataSource.getLogWriter()`.

    Parameters:
      `xaDataSourceInstance` - XADataSource instance